/*
 * xhtmlbuffer.h
 * xhtmlite
 *
 * by Doug Wolfe
 * doug@wolfescience.com 
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <gtk/gtk.h>

//for xml
#include <libxml/xmlreader.h>
#include <libxml/encoding.h>
#include <libxml/xmlwriter.h>

enum {COLOR_FOREGROUND, COLOR_BACKGROUND};

GtkTextBuffer *xhtmlite_create_buffer (GtkTextView *textview, gboolean writeable);
void on_buffer_changed (GtkTextBuffer *textbuffer, gpointer user_data);

gchar *xhtmlite_write_as_markup (GtkTextBuffer *textbuffer);
gchar *xhtmlite_write (GtkTextBuffer *textbuffer);
gchar *xhtmlite_write_range (GtkTextBuffer *textbuffer, GtkTextIter *start, GtkTextIter *end);

void xhtmlite_process_node (GtkTextBuffer *textbuffer, xmlTextReaderPtr reader);
void xhtmlite_import (GtkTextBuffer *textbuffer, gchar * xml, gboolean markup);
int xhtmlite_insert (GtkTextBuffer *textbuffer, gchar * xml, GtkTextIter *start, gboolean markup);
int strrepl(char *InputString,char *StringToFind, char *StringToReplace,char *output);

void xhtmlite_toggle_bold (GtkTextBuffer *textbuffer, gboolean enable);
void xhtmlite_toggle_italic (GtkTextBuffer *textbuffer, gboolean enable);
void xhtmlite_toggle_underline (GtkTextBuffer *textbuffer, gboolean enable);
void xhtmlite_toggle_strikethrough (GtkTextBuffer *textbuffer, gboolean enable);
void xhtmlite_toggle_superscript (GtkTextBuffer *textbuffer, gboolean enable);
void xhtmlite_toggle_subscript (GtkTextBuffer *textbuffer, gboolean enable);
void xhtmlite_adjust_fontsize_absolute(GtkTextBuffer *textbuffer, gchar * fontsize);
void xhtmlite_change_fontfamily (GtkTextBuffer * textbuffer, GtkWidget * textview, gchar * fontfamily);

void xhtmlite_open_symbol_dialog (GtkWindow *parent_window, GtkTextBuffer *textbuffer);
void xhtmlite_open_font_color_dialog (GtkWindow *parent_window, GtkTextBuffer * textbuffer);
void xhtmlite_open_highlight_color_dialog (GtkWindow *parent_window, GtkTextBuffer * textbuffer);
void xhtmlite_on_button_symbol_activate (GtkButton *button, gpointer user_data);
void xhtmlite_on_button_symbol_clicked (GtkButton *button, gpointer user_data);
void xhtmlite_insert_link (GtkWindow *parent_window, GtkTextBuffer *textbuffer);
